(*
  Un Tipo Astratto 't queue per code polimorfe di valori di tipo generico 't \`e un valore
  strutturato IMMUTABLE dotate delle seguenti operazioni con signature funzionale:
  	isEmpty: 't queue -> bool
  	isIn: 't queue -> 't -> int    (quante occorrenze del secondo argomento)
  	get: 't queue -> 't 
  	add: 't queue -> 't -> 't queue  
  	remove: 't queue -> 't queue
  	removeAll: 't queue -> 't -> 't queue    (rimuove gli uguali al secondo argomento)
e, in aggiunta:
    + un costruttore pubblico che inizializza la coda agli elementi della lista a cui e' 
      applicato;
    + eccezioni pubbliche che si ritenga utile aggiungere;
  	+ toString 't queue -> string 
  Si forniscano API ed ADT con AF ed I e si esegua il test nel file accluso       
*)

module type QUEUE =
  sig
	type 't queue
	...
	val toString: 't queue -> ('t -> string) -> string
  end;;

module Queue =
(struct
 type 't queue = Q of 't list * 't list
 (*
 AF(c) =
 I(c) =
 *)
 let mk xx = Q([],xx)
   ...
 let toString (Q(inp,out)) toStringT = 
 		let c = out @ (List.rev inp) in
 		"<"^(List.fold_right (fun x a -> (toStringT x)^", "^a) c "<") 	
 end:QUEUE);;

