(*
  Un Tipo Astratto 'a queue per code polimorfe di valori di tipo generico 'a \`e un valore
  strutturato IMMUTABLE dotate delle seguenti operazioni con signature funzionale:
  	isEmpty: 'a queue -> bool
  	isIn: 't queue -> 't -> int    (quante occorrenze del secondo argomento)
  	add: 'a queue -> 'a -> 'a queue  
  	remove 'a queue -> 'a queue
  	removeAll 'a queue -> 'a -> 'a queue       (rimuove gli uguali al secondo argomento)
  in aggiunta a:
    + un costruttore pubblico che inizializza la coda agli elementi della lista a cui e' 
      applicato;
    + eccezioni pubbliche che si ritenga utile aggiungere, e l'additional:
  	+ toString 'a queue -> string 
  Si completi il file Queue.ml (per fornire API ed ADT con AF ed I) e si esegua il test nel
   file accluso       
*)



open Queue;;
let q1 = mk ["luigi";"luca"; "laura"; "michele"];;
toString q1 (Printf.sprintf "%s");;
let q2 = remove q1;;
let q3 = (add(add(add(add(add(add q2 "luca") "giacomo")
 "luca") "luciano") "franca") "silvia");;
let q4 = List.fold_left (add) q3 ["maria";"paola";"anna";"marco";"francesca"];;
toString q4 (Printf.sprintf "%s");;
let q5 = removeAll q4 "luca" ;;
toString q5 (Printf.sprintf "%s");;


(* Esecuzione dopo il caricamento del file "QueueSol.ml"
module Queue : QUEUE
# #use "QueueTest.ml";;
val q1 : string Queue.queue = <abstr>
- : string = "<luigi, luca, laura, michele, <"
val q2 : string Queue.queue = <abstr>
val q3 : string Queue.queue = <abstr>
val q4 : string Queue.queue = <abstr>
- : string =
"<luca, laura, michele, luca, giacomo, luca, luciano, franca, silvia, maria, paola, anna, marco, francesca, <"
val q5 : string Queue.queue = <abstr>
- : string =
"<laura, michele, giacomo, luciano, franca, silvia, maria, paola, anna, marco, francesca, <"
# 
*)
